dracut.sh: always assemble /usr in the initramfs
[platform/upstream/dracut.git] / dracut.sh
1 #!/bin/bash
2 # -*- mode: shell-script; indent-tabs-mode: nil; sh-basic-offset: 4; -*-
3 # ex: ts=8 sw=4 sts=4 et filetype=sh
4 #
5 # Generator script for a dracut initramfs
6 # Tries to retain some degree of compatibility with the command line
7 # of the various mkinitrd implementations out there
8 #
9
10 # Copyright 2005-2013 Red Hat, Inc.  All rights reserved.
11 #
12 # This program is free software; you can redistribute it and/or modify
13 # it under the terms of the GNU General Public License as published by
14 # the Free Software Foundation; either version 2 of the License, or
15 # (at your option) any later version.
16 #
17 # This program is distributed in the hope that it will be useful,
18 # but WITHOUT ANY WARRANTY; without even the implied warranty of
19 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
20 # GNU General Public License for more details.
21 #
22 # You should have received a copy of the GNU General Public License
23 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
24 #
25
26 # store for logging
27 dracut_args=( "$@" )
28
29 set -o pipefail
30
31 usage() {
32     [[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut
33     if [[ -f $dracutbasedir/dracut-version.sh ]]; then
34         . $dracutbasedir/dracut-version.sh
35     fi
36
37 #                                                       80x25 linebreak here ^
38     cat << EOF
39 Usage: $0 [OPTION]... [<initramfs> [<kernel-version>]]
40
41 Version: $DRACUT_VERSION
42
43 Creates initial ramdisk images for preloading modules
44
45   -h, --help  Display all options
46
47 If a [LIST] has multiple arguments, then you have to put these in quotes.
48
49 For example:
50
51     # dracut --add-drivers "module1 module2"  ...
52
53 EOF
54 }
55
56 long_usage() {
57     [[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut
58     if [[ -f $dracutbasedir/dracut-version.sh ]]; then
59         . $dracutbasedir/dracut-version.sh
60     fi
61
62 #                                                       80x25 linebreak here ^
63     cat << EOF
64 Usage: $0 [OPTION]... [<initramfs> [<kernel-version>]]
65
66 Version: $DRACUT_VERSION
67
68 Creates initial ramdisk images for preloading modules
69
70   --kver [VERSION]      Set kernel version to [VERSION].
71   -f, --force           Overwrite existing initramfs file.
72   -a, --add [LIST]      Add a space-separated list of dracut modules.
73   -m, --modules [LIST]  Specify a space-separated list of dracut modules to
74                          call when building the initramfs. Modules are located
75                          in /usr/lib/dracut/modules.d.
76   -o, --omit [LIST]     Omit a space-separated list of dracut modules.
77   --force-add [LIST]    Force to add a space-separated list of dracut modules
78                          to the default set of modules, when -H is specified.
79   -d, --drivers [LIST]  Specify a space-separated list of kernel modules to
80                          exclusively include in the initramfs.
81   --add-drivers [LIST]  Specify a space-separated list of kernel
82                          modules to add to the initramfs.
83   --omit-drivers [LIST] Specify a space-separated list of kernel
84                          modules not to add to the initramfs.
85   --filesystems [LIST]  Specify a space-separated list of kernel filesystem
86                          modules to exclusively include in the generic
87                          initramfs.
88   -k, --kmoddir [DIR]   Specify the directory, where to look for kernel
89                          modules
90   --fwdir [DIR]         Specify additional directories, where to look for
91                          firmwares, separated by :
92   --kernel-only         Only install kernel drivers and firmware files
93   --no-kernel           Do not install kernel drivers and firmware files
94   --early-microcode     Combine early microcode with ramdisk
95   --no-early-microcode  Do not combine early microcode with ramdisk
96   --kernel-cmdline [PARAMETERS] Specify default kernel command line parameters
97   --strip               Strip binaries in the initramfs
98   --nostrip             Do not strip binaries in the initramfs
99   --hardlink            Hardlink files in the initramfs
100   --nohardlink          Do not hardlink files in the initramfs
101   --prefix [DIR]        Prefix initramfs files with [DIR]
102   --noprefix            Do not prefix initramfs files
103   --mdadmconf           Include local /etc/mdadm.conf
104   --nomdadmconf         Do not include local /etc/mdadm.conf
105   --lvmconf             Include local /etc/lvm/lvm.conf
106   --nolvmconf           Do not include local /etc/lvm/lvm.conf
107   --fscks [LIST]        Add a space-separated list of fsck helpers.
108   --nofscks             Inhibit installation of any fsck helpers.
109   --ro-mnt              Mount / and /usr read-only by default.
110   -h, --help            This message
111   --debug               Output debug information of the build process
112   --profile             Output profile information of the build process
113   -L, --stdlog [0-6]    Specify logging level (to standard error)
114                          0 - suppress any messages
115                          1 - only fatal errors
116                          2 - all errors
117                          3 - warnings
118                          4 - info
119                          5 - debug info (here starts lots of output)
120                          6 - trace info (and even more)
121   -v, --verbose         Increase verbosity level
122   -q, --quiet           Decrease verbosity level
123   -c, --conf [FILE]     Specify configuration file to use.
124                          Default: /etc/dracut.conf
125   --confdir [DIR]       Specify configuration directory to use *.conf files
126                          from. Default: /etc/dracut.conf.d
127   --tmpdir [DIR]        Temporary directory to be used instead of default
128                          /var/tmp.
129   -l, --local           Local mode. Use modules from the current working
130                          directory instead of the system-wide installed in
131                          /usr/lib/dracut/modules.d.
132                          Useful when running dracut from a git checkout.
133   -H, --hostonly        Host-Only mode: Install only what is needed for
134                          booting the local host instead of a generic host.
135   -N, --no-hostonly     Disables Host-Only mode
136   --fstab               Use /etc/fstab to determine the root device.
137   --add-fstab [FILE]    Add file to the initramfs fstab
138   --mount "[DEV] [MP] [FSTYPE] [FSOPTS]"
139                         Mount device [DEV] on mountpoint [MP] with filesystem
140                         [FSTYPE] and options [FSOPTS] in the initramfs
141   --add-device "[DEV]"  Bring up [DEV] in initramfs
142   -i, --include [SOURCE] [TARGET]
143                         Include the files in the SOURCE directory into the
144                          Target directory in the final initramfs.
145                         If SOURCE is a file, it will be installed to TARGET
146                          in the final initramfs.
147   -I, --install [LIST]  Install the space separated list of files into the
148                          initramfs.
149   --gzip                Compress the generated initramfs using gzip.
150                          This will be done by default, unless another
151                          compression option or --no-compress is passed.
152   --bzip2               Compress the generated initramfs using bzip2.
153                          Make sure your kernel has bzip2 decompression support
154                          compiled in, otherwise you will not be able to boot.
155   --lzma                Compress the generated initramfs using lzma.
156                          Make sure your kernel has lzma support compiled in,
157                          otherwise you will not be able to boot.
158   --xz                  Compress the generated initramfs using xz.
159                          Make sure that your kernel has xz support compiled
160                          in, otherwise you will not be able to boot.
161   --compress [COMPRESSION] Compress the generated initramfs with the
162                          passed compression program.  Make sure your kernel
163                          knows how to decompress the generated initramfs,
164                          otherwise you will not be able to boot.
165   --no-compress         Do not compress the generated initramfs.  This will
166                          override any other compression options.
167   --list-modules        List all available dracut modules.
168   -M, --show-modules    Print included module's name to standard output during
169                          build.
170   --keep                Keep the temporary initramfs for debugging purposes
171   --printsize           Print out the module install size
172   --sshkey [SSHKEY]     Add ssh key to initramfs (use with ssh-client module)
173
174 If [LIST] has multiple arguments, then you have to put these in quotes.
175
176 For example:
177
178     # dracut --add-drivers "module1 module2"  ...
179
180 EOF
181 }
182
183 # function push()
184 # push values to a stack
185 # $1 = stack variable
186 # $2.. values
187 # example:
188 # push stack 1 2 "3 4"
189 push() {
190     local _i
191     local __stack=$1; shift
192     for _i in "$@"; do
193         eval ${__stack}'[${#'${__stack}'[@]}]="$_i"'
194     done
195 }
196
197 # function pop()
198 # pops the last value from a stack
199 # assigns value to second argument variable
200 # or echo to stdout, if no second argument
201 # $1 = stack variable
202 # $2 = optional variable to store the value
203 # example:
204 # pop stack val
205 # val=$(pop stack)
206 pop() {
207     local __stack=$1; shift
208     local __resultvar=$1
209     local _value;
210     # check for empty stack
211     eval '[[ ${#'${__stack}'[@]} -eq 0 ]] && return 1'
212
213     eval _value='${'${__stack}'[${#'${__stack}'[@]}-1]}'
214
215     if [[ "$__resultvar" ]]; then
216         eval $__resultvar="'$_value'"
217     else
218         printf "%s" "$_value"
219     fi
220     eval unset ${__stack}'[${#'${__stack}'[@]}-1]'
221     return 0
222 }
223
224 # Little helper function for reading args from the commandline.
225 # it automatically handles -a b and -a=b variants, and returns 1 if
226 # we need to shift $3.
227 read_arg() {
228     # $1 = arg name
229     # $2 = arg value
230     # $3 = arg parameter
231     local rematch='^[^=]*=(.*)$'
232     if [[ $2 =~ $rematch ]]; then
233         read "$1" <<< "${BASH_REMATCH[1]}"
234     else
235         read "$1" <<< "$3"
236         # There is no way to shift our callers args, so
237         # return 1 to indicate they should do it instead.
238         return 1
239     fi
240 }
241
242 dropindirs_sort()
243 {
244     local suffix=$1; shift
245     local -a files
246     local f d
247
248     for d in "$@"; do
249         for i in "$d/"*"$suffix"; do
250             if [[ -e "$i" ]]; then
251                 printf "%s\n" "${i##*/}"
252             fi
253         done
254     done | sort -Vu | {
255         readarray -t files
256
257         for f in "${files[@]}"; do
258             for d in "$@"; do
259                 if [[ -e "$d/$f" ]]; then
260                     printf "%s\n" "$d/$f"
261                     continue 2
262                 fi
263             done
264         done
265     }
266 }
267
268 verbosity_mod_l=0
269 unset kernel
270 unset outfile
271
272 # Workaround -i, --include taking 2 arguments
273 set -- "${@/--include/++include}"
274
275 # This prevents any long argument ending with "-i"
276 # -i, like --opt-i but I think we can just prevent that
277 set -- "${@/%-i/++include}"
278
279 TEMP=$(unset POSIXLY_CORRECT; getopt \
280     -o "a:m:o:d:I:k:c:L:fvqlHhMN" \
281     --long kver: \
282     --long add: \
283     --long force-add: \
284     --long add-drivers: \
285     --long omit-drivers: \
286     --long modules: \
287     --long omit: \
288     --long drivers: \
289     --long filesystems: \
290     --long install: \
291     --long fwdir: \
292     --long libdirs: \
293     --long fscks: \
294     --long add-fstab: \
295     --long mount: \
296     --long device: \
297     --long nofscks: \
298     --long ro-mnt \
299     --long kmoddir: \
300     --long conf: \
301     --long confdir: \
302     --long tmpdir: \
303     --long stdlog: \
304     --long compress: \
305     --long prefix: \
306     --long force \
307     --long kernel-only \
308     --long no-kernel \
309     --long kernel-cmdline: \
310     --long strip \
311     --long nostrip \
312     --long hardlink \
313     --long nohardlink \
314     --long noprefix \
315     --long mdadmconf \
316     --long nomdadmconf \
317     --long lvmconf \
318     --long nolvmconf \
319     --long debug \
320     --long profile \
321     --long sshkey: \
322     --long verbose \
323     --long quiet \
324     --long local \
325     --long hostonly \
326     --long host-only \
327     --long no-hostonly \
328     --long no-host-only \
329     --long fstab \
330     --long help \
331     --long bzip2 \
332     --long lzma \
333     --long xz \
334     --long no-compress \
335     --long gzip \
336     --long list-modules \
337     --long show-modules \
338     --long keep \
339     --long printsize \
340     --long regenerate-all \
341     --long noimageifnotneeded \
342     -- "$@")
343
344 if (( $? != 0 )); then
345     usage
346     exit 1
347 fi
348
349 eval set -- "$TEMP"
350
351 while :; do
352     case $1 in
353         --kver)        kernel="$2"; shift;;
354         -a|--add)      push add_dracutmodules_l  "$2"; shift;;
355         --force-add)   push force_add_dracutmodules_l  "$2"; shift;;
356         --add-drivers) push add_drivers_l        "$2"; shift;;
357         --omit-drivers) push omit_drivers_l      "$2"; shift;;
358         -m|--modules)  push dracutmodules_l      "$2"; shift;;
359         -o|--omit)     push omit_dracutmodules_l "$2"; shift;;
360         -d|--drivers)  push drivers_l            "$2"; shift;;
361         --filesystems) push filesystems_l        "$2"; shift;;
362         -I|--install)  push install_items_l      "$2"; shift;;
363         --fwdir)       push fw_dir_l             "$2"; shift;;
364         --libdirs)     push libdirs_l            "$2"; shift;;
365         --fscks)       push fscks_l              "$2"; shift;;
366         --add-fstab)   push add_fstab_l          "$2"; shift;;
367         --mount)       push fstab_lines          "$2"; shift;;
368         --add-device|--device)
369                        push add_device_l         "$2"; shift;;
370         --kernel-cmdline) push kernel_cmdline_l  "$2"; shift;;
371         --nofscks)     nofscks_l="yes";;
372         --ro-mnt)      ro_mnt_l="yes";;
373         -k|--kmoddir)  drivers_dir_l="$2"; shift;;
374         -c|--conf)     conffile="$2"; shift;;
375         --confdir)     confdir="$2"; shift;;
376         --tmpdir)      tmpdir_l="$2"; shift;;
377         -L|--stdlog)   stdloglvl_l="$2"; shift;;
378         --compress)    compress_l="$2"; shift;;
379         --prefix)      prefix_l="$2"; shift;;
380         -f|--force)    force=yes;;
381         --kernel-only) kernel_only="yes"; no_kernel="no";;
382         --no-kernel)   kernel_only="no"; no_kernel="yes";;
383         --early-microcode) early_microcode="yes";;
384         --no-early-microcode) early_microcode="no";;
385         --strip)       do_strip_l="yes";;
386         --nostrip)     do_strip_l="no";;
387         --hardlink)    do_hardlink_l="yes";;
388         --nohardlink)  do_hardlink_l="no";;
389         --noprefix)    prefix_l="/";;
390         --mdadmconf)   mdadmconf_l="yes";;
391         --nomdadmconf) mdadmconf_l="no";;
392         --lvmconf)     lvmconf_l="yes";;
393         --nolvmconf)   lvmconf_l="no";;
394         --debug)       debug="yes";;
395         --profile)     profile="yes";;
396         --sshkey)      sshkey="$2"; shift;;
397         -v|--verbose)  ((verbosity_mod_l++));;
398         -q|--quiet)    ((verbosity_mod_l--));;
399         -l|--local)
400                        allowlocal="yes"
401                        [[ -f "$(readlink -f "${0%/*}")/dracut-functions.sh" ]] \
402                            && dracutbasedir="$(readlink -f "${0%/*}")"
403                        ;;
404         -H|--hostonly|--host-only)
405                        hostonly_l="yes" ;;
406         -N|--no-hostonly|--no-host-only)
407                        hostonly_l="no" ;;
408         --fstab)       use_fstab_l="yes" ;;
409         -h|--help)     long_usage; exit 1 ;;
410         -i|--include)  push include_src "$2"
411                        shift;;
412         --bzip2)       compress_l="bzip2";;
413         --lzma)        compress_l="lzma";;
414         --xz)          compress_l="xz";;
415         --no-compress) _no_compress_l="cat";;
416         --gzip)        compress_l="gzip";;
417         --list-modules) do_list="yes";;
418         -M|--show-modules)
419                        show_modules_l="yes"
420                        ;;
421         --keep)        keep="yes";;
422         --printsize)   printsize="yes";;
423         --regenerate-all) regenerate_all="yes";;
424         --noimageifnotneeded) noimageifnotneeded="yes";;
425
426         --) shift; break;;
427
428         *)  # should not even reach this point
429             printf "\n!Unknown option: '%s'\n\n" "$1" >&2; usage; exit 1;;
430     esac
431     shift
432 done
433
434 # getopt cannot handle multiple arguments, so just handle "-I,--include"
435 # the old fashioned way
436
437 while (($# > 0)); do
438     case ${1%%=*} in
439         ++include) push include_src "$2"
440                        push include_target "$3"
441                        shift 2;;
442         *)
443             if ! [[ ${outfile+x} ]]; then
444                 outfile=$1
445             elif ! [[ ${kernel+x} ]]; then
446                 kernel=$1
447             else
448                 printf "\nUnknown arguments: %s\n\n" "$*" >&2
449                 usage; exit 1;
450             fi
451             ;;
452     esac
453     shift
454 done
455
456 if [[ $regenerate_all == "yes" ]]; then
457     ret=0
458     if [[ $kernel ]]; then
459         printf -- "--regenerate-all cannot be called with a kernel version\n" >&2
460         exit 1
461     fi
462
463     if [[ $outfile ]]; then
464         printf -- "--regenerate-all cannot be called with a image file\n" >&2
465         exit 1
466     fi
467
468     ((len=${#dracut_args[@]}))
469     for ((i=0; i < len; i++)); do
470         [[ ${dracut_args[$i]} == "--regenerate-all" ]] && \
471             unset dracut_args[$i]
472     done
473
474     cd /lib/modules
475     for i in *; do
476         [[ -f $i/modules.builtin ]] || continue
477         dracut --kver="$i" "${dracut_args[@]}"
478         ((ret+=$?))
479     done
480     exit $ret
481 elif [[ $kernel ]]; then
482     if ! [[ -d /lib/modules/$kernel ]] && [[ $no_kernel != yes ]]; then
483         printf -- "Kernel version $kernel has no modules in /lib/modules/$kernel\n" >&2
484         exit 1
485     fi
486 fi
487
488 if ! [[ $kernel ]]; then
489     kernel=$(uname -r)
490 fi
491
492 if ! [[ $outfile ]]; then
493     [[ -f /etc/machine-id ]] && read MACHINE_ID < /etc/machine-id
494
495     if [[ $MACHINE_ID ]] && ( [[ -d /boot/${MACHINE_ID} ]] || [[ -L /boot/${MACHINE_ID} ]] ); then
496         outfile="/boot/${MACHINE_ID}/$kernel/initrd"
497     else
498         outfile="/boot/initramfs-$kernel.img"
499     fi
500 fi
501
502 for i in /usr/sbin /sbin /usr/bin /bin; do
503     rl=$i
504     if [ -L "$i" ]; then
505         rl=$(readlink -f $i)
506     fi
507     if [[ "$NPATH" != "*:$rl*" ]] ; then
508         NPATH+=":$rl"
509     fi
510 done
511 export PATH="${NPATH#:}"
512 unset LC_MESSAGES
513 unset LC_CTYPE
514 export LC_ALL=C
515 export LANG=C
516 unset NPATH
517 unset LD_LIBRARY_PATH
518 unset GREP_OPTIONS
519
520 export DRACUT_LOG_LEVEL=warning
521 [[ $debug ]] && {
522     export DRACUT_LOG_LEVEL=debug
523     export PS4='${BASH_SOURCE}@${LINENO}(${FUNCNAME[0]}): ';
524     set -x
525 }
526
527 [[ $profile ]] && {
528     export PS4='+ $(date "+%s.%N") ${BASH_SOURCE}@${LINENO}: ';
529     set -x
530     debug=yes
531 }
532
533 [[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut
534
535 # if we were not passed a config file, try the default one
536 if [[ ! -f $conffile ]]; then
537     if [[ $allowlocal ]]; then
538         conffile="$dracutbasedir/dracut.conf"
539     else
540         conffile="/etc/dracut.conf"
541     fi
542 fi
543
544 if [[ ! -d $confdir ]]; then
545     if [[ $allowlocal ]]; then
546         confdir="$dracutbasedir/dracut.conf.d"
547     else
548         confdir="/etc/dracut.conf.d"
549     fi
550 fi
551
552 # source our config file
553 [[ -f $conffile ]] && . "$conffile"
554
555 # source our config dir
556 for f in $(dropindirs_sort ".conf" "$confdir" "$dracutbasedir/dracut.conf.d"); do
557     [[ -e $f ]] && . "$f"
558 done
559
560 # these optins add to the stuff in the config file
561 if (( ${#add_dracutmodules_l[@]} )); then
562     while pop add_dracutmodules_l val; do
563         add_dracutmodules+=" $val "
564     done
565 fi
566
567 if (( ${#force_add_dracutmodules_l[@]} )); then
568     while pop force_add_dracutmodules_l val; do
569         force_add_dracutmodules+=" $val "
570     done
571 fi
572
573 if (( ${#fscks_l[@]} )); then
574     while pop fscks_l val; do
575         fscks+=" $val "
576     done
577 fi
578
579 if (( ${#add_fstab_l[@]} )); then
580     while pop add_fstab_l val; do
581         add_fstab+=" $val "
582     done
583 fi
584
585 if (( ${#fstab_lines_l[@]} )); then
586     while pop fstab_lines_l val; do
587         push fstab_lines $val
588     done
589 fi
590
591 if (( ${#install_items_l[@]} )); then
592     while pop install_items_l val; do
593         install_items+=" $val "
594     done
595 fi
596
597 # these options override the stuff in the config file
598 if (( ${#dracutmodules_l[@]} )); then
599     dracutmodules=''
600     while pop dracutmodules_l val; do
601         dracutmodules+="$val "
602     done
603 fi
604
605 if (( ${#omit_dracutmodules_l[@]} )); then
606     omit_dracutmodules=''
607     while pop omit_dracutmodules_l val; do
608         omit_dracutmodules+="$val "
609     done
610 fi
611
612 if (( ${#filesystems_l[@]} )); then
613     filesystems=''
614     while pop filesystems_l val; do
615         filesystems+="$val "
616     done
617 fi
618
619 if (( ${#fw_dir_l[@]} )); then
620     fw_dir=''
621     while pop fw_dir_l val; do
622         fw_dir+="$val "
623     done
624 fi
625
626 if (( ${#libdirs_l[@]} )); then
627     libdirs=''
628     while pop libdirs_l val; do
629         libdirs+="$val "
630     done
631 fi
632
633 [[ $stdloglvl_l ]] && stdloglvl=$stdloglvl_l
634 [[ ! $stdloglvl ]] && stdloglvl=4
635 stdloglvl=$((stdloglvl + verbosity_mod_l))
636 ((stdloglvl > 6)) && stdloglvl=6
637 ((stdloglvl < 0)) && stdloglvl=0
638
639 [[ $drivers_dir_l ]] && drivers_dir=$drivers_dir_l
640 [[ $do_strip_l ]] && do_strip=$do_strip_l
641 [[ $do_strip ]] || do_strip=yes
642 [[ $do_hardlink_l ]] && do_hardlink=$do_hardlink_l
643 [[ $do_hardlink ]] || do_hardlink=yes
644 [[ $prefix_l ]] && prefix=$prefix_l
645 [[ $prefix = "/" ]] && unset prefix
646 [[ $hostonly_l ]] && hostonly=$hostonly_l
647 [[ $use_fstab_l ]] && use_fstab=$use_fstab_l
648 [[ $mdadmconf_l ]] && mdadmconf=$mdadmconf_l
649 [[ $lvmconf_l ]] && lvmconf=$lvmconf_l
650 [[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut
651 [[ $fw_dir ]] || fw_dir="/lib/firmware/updates /lib/firmware"
652 [[ $tmpdir_l ]] && tmpdir="$tmpdir_l"
653 [[ $tmpdir ]] || tmpdir=/var/tmp
654 [[ $compress_l ]] && compress=$compress_l
655 [[ $show_modules_l ]] && show_modules=$show_modules_l
656 [[ $nofscks_l ]] && nofscks="yes"
657 [[ $ro_mnt_l ]] && ro_mnt="yes"
658 # eliminate IFS hackery when messing with fw_dir
659 fw_dir=${fw_dir//:/ }
660
661 # handle compression options.
662 [[ $compress ]] || compress="gzip"
663 case $compress in
664     bzip2) compress="bzip2 -9";;
665     lzma)  compress="lzma -9";;
666     xz)    compress="xz --check=crc32 --lzma2=dict=1MiB";;
667     gzip)  compress="gzip -9"; command -v pigz > /dev/null 2>&1 && compress="pigz -9";;
668 esac
669 if [[ $_no_compress_l = "cat" ]]; then
670     compress="cat"
671 fi
672
673 [[ $hostonly = yes ]] && hostonly="-h"
674 [[ $hostonly != "-h" ]] && unset hostonly
675
676 readonly TMPDIR="$tmpdir"
677 readonly initdir="$(mktemp --tmpdir="$TMPDIR/" -d -t initramfs.XXXXXX)"
678 [ -d "$initdir" ] || {
679     printf "%s\n" "dracut: mktemp --tmpdir=\"$TMPDIR/\" -d -t initramfs.XXXXXX failed." >&2
680     exit 1
681 }
682
683 if [[ $early_microcode = yes ]]; then
684     readonly microcode_dir="$(mktemp --tmpdir="$TMPDIR/" -d -t early_microcode.XXXXXX)"
685     [ -d "$microcode_dir" ] || {
686         printf "%s\n" "dracut: mktemp --tmpdir=\"$TMPDIR/\" -d -t early_microcode.XXXXXX failed." >&2
687         exit 1
688     }
689 fi
690 # clean up after ourselves no matter how we die.
691 trap '
692     ret=$?;
693     [[ $outfile ]] && [[ -f $outfile.$$ ]] && rm -f -- "$outfile.$$";
694     [[ $keep ]] && echo "Not removing $initdir." >&2 || { [[ $initdir ]] && rm -rf -- "$initdir"; };
695     [[ $keep ]] && echo "Not removing $microcode_dir." >&2 || { [[ $microcode_dir ]] && rm -Rf -- "$microcode_dir"; };
696     [[ $_dlogdir ]] && rm -Rf -- "$_dlogdir";
697     exit $ret;
698     ' EXIT
699
700 # clean up after ourselves no matter how we die.
701 trap 'exit 1;' SIGINT
702
703 export DRACUT_KERNEL_LAZY="1"
704 export DRACUT_RESOLVE_LAZY="1"
705
706 if [[ -f $dracutbasedir/dracut-functions.sh ]]; then
707     . $dracutbasedir/dracut-functions.sh
708 else
709     printf "%s\n" "dracut: Cannot find $dracutbasedir/dracut-functions.sh." >&2
710     printf "%s\n" "dracut: Are you running from a git checkout?" >&2
711     printf "%s\n" "dracut: Try passing -l as an argument to $0" >&2
712     exit 1
713 fi
714
715 inst /bin/sh
716 if ! $DRACUT_INSTALL ${initdir+-D "$initdir"} -R "$initdir/bin/sh" &>/dev/null; then
717     unset DRACUT_RESOLVE_LAZY
718     export DRACUT_RESOLVE_DEPS=1
719 fi
720 rm -fr -- ${initdir}/*
721
722 if [[ -f $dracutbasedir/dracut-version.sh ]]; then
723     . $dracutbasedir/dracut-version.sh
724 fi
725
726 # Verify bash version, current minimum is 3.1
727 if (( BASH_VERSINFO[0] < 4 )); then
728     dfatal 'You need at least Bash 4 to use dracut, sorry.'
729     exit 1
730 fi
731
732 dracutfunctions=$dracutbasedir/dracut-functions.sh
733 export dracutfunctions
734
735 if (( ${#drivers_l[@]} )); then
736     drivers=''
737     while pop drivers_l val; do
738         drivers+="$val "
739     done
740 fi
741 drivers=${drivers/-/_}
742
743 if (( ${#add_drivers_l[@]} )); then
744     while pop add_drivers_l val; do
745         add_drivers+=" $val "
746     done
747 fi
748 add_drivers=${add_drivers/-/_}
749
750 if (( ${#omit_drivers_l[@]} )); then
751     while pop omit_drivers_l val; do
752         omit_drivers+=" $val "
753     done
754 fi
755 omit_drivers=${omit_drivers/-/_}
756
757 if (( ${#kernel_cmdline_l[@]} )); then
758     while pop kernel_cmdline_l val; do
759         kernel_cmdline+=" $val "
760     done
761 fi
762
763 omit_drivers_corrected=""
764 for d in $omit_drivers; do
765     [[ " $drivers $add_drivers " == *\ $d\ * ]] && continue
766     omit_drivers_corrected+="$d|"
767 done
768 omit_drivers="${omit_drivers_corrected%|}"
769 unset omit_drivers_corrected
770
771 # prepare args for logging
772 for ((i=0; i < ${#dracut_args[@]}; i++)); do
773     [[ "${dracut_args[$i]}" == *\ * ]] && \
774         dracut_args[$i]="\"${dracut_args[$i]}\""
775         #" keep vim happy
776 done
777 dinfo "Executing: $0 ${dracut_args[@]}"
778
779 [[ $do_list = yes ]] && {
780     for mod in $dracutbasedir/modules.d/*; do
781         [[ -d $mod ]] || continue;
782         [[ -e $mod/install || -e $mod/installkernel || \
783             -e $mod/module-setup.sh ]] || continue
784         printf "%s\n" "${mod##*/??}"
785     done
786     exit 0
787 }
788
789 # This is kinda legacy -- eventually it should go away.
790 case $dracutmodules in
791     ""|auto) dracutmodules="all" ;;
792 esac
793
794 abs_outfile=$(readlink -f "$outfile") && outfile="$abs_outfile"
795
796 if [[ -d $srcmods ]]; then
797     [[ -f $srcmods/modules.dep ]] || {
798       dwarn "$srcmods/modules.dep is missing. Did you run depmod?"
799     }
800 fi
801
802 if [[ -f $outfile && ! $force ]]; then
803     dfatal "Will not override existing initramfs ($outfile) without --force"
804     exit 1
805 fi
806
807 outdir=${outfile%/*}
808 [[ $outdir ]] || outdir="/"
809
810 if [[ ! -d "$outdir" ]]; then
811     dfatal "Can't write to $outdir: Directory $outdir does not exist or is not accessible."
812     exit 1
813 elif [[ ! -w "$outdir" ]]; then
814     dfatal "No permission to write to $outdir."
815     exit 1
816 elif [[ -f "$outfile" && ! -w "$outfile" ]]; then
817     dfatal "No permission to write $outfile."
818     exit 1
819 fi
820
821 # Need to be able to have non-root users read stuff (rpcbind etc)
822 chmod 755 "$initdir"
823
824 if [[ $hostonly ]]; then
825     for i in /sys /proc /run /dev; do
826         if ! findmnt --target "$i" &>/dev/null; then
827             dwarning "Turning off host-only mode: '$i' is not mounted!"
828             unset hostonly
829         fi
830     done
831     if ! [[ -d /run/udev/data ]]; then
832         dwarning "Turning off host-only mode: udev database not found!"
833         unset hostonly
834     fi
835 fi
836
837 declare -A host_fs_types
838
839 for line in "${fstab_lines[@]}"; do
840     set -- $line
841     #dev mp fs fsopts
842     push host_devs "$1"
843     host_fs_types["$1"]="$3"
844 done
845
846 for f in $add_fstab; do
847     [[ -e $f ]] || continue
848     while read dev rest; do
849         push host_devs "$dev"
850     done < "$f"
851 done
852
853 for dev in $add_device; do
854     push host_devs "$dev"
855 done
856
857 if (( ${#add_device_l[@]} )); then
858     while pop add_device_l val; do
859         add_device+=" $val "
860         push host_devs "$val"
861     done
862 fi
863
864 if [[ $hostonly ]]; then
865     # in hostonly mode, determine all devices, which have to be accessed
866     # and examine them for filesystem types
867
868     for mp in \
869         "/" \
870         "/etc" \
871         "/bin" \
872         "/sbin" \
873         "/lib" \
874         "/lib64" \
875         "/usr" \
876         "/usr/bin" \
877         "/usr/sbin" \
878         "/usr/lib" \
879         "/usr/lib64" \
880         "/boot";
881     do
882         mp=$(readlink -f "$mp")
883         mountpoint "$mp" >/dev/null 2>&1 || continue
884         _dev=$(find_block_device "$mp")
885         _bdev=$(readlink -f "/dev/block/$_dev")
886         [[ -b $_bdev ]] && _dev=$_bdev
887         push host_devs $_dev
888         [[ "$_mp" == "/" ]] && root_dev="$_dev"
889         push host_devs "$_dev"
890     done
891
892     if [[ -f /proc/swaps ]] && [[ -f /etc/fstab ]]; then
893         while read dev type rest; do
894             [[ -b $dev ]] || continue
895             [[ "$type" == "partition" ]] || continue
896
897             while read _d _m _t _o _r; do
898                 [[ "$_d" == \#* ]] && continue
899                 [[ $_d ]] || continue
900                 [[ $_t != "swap" ]] || [[ $_m != "swap" ]] && continue
901                 [[ "$_o" == *noauto* ]] && continue
902                 [[ "$_d" == UUID\=* ]] && _d="/dev/disk/by-uuid/${_d#UUID=}"
903                 [[ "$_d" == LABEL\=* ]] && _d="/dev/disk/by-label/$_d#LABEL=}"
904                 [[ "$_d" -ef "$dev" ]] || continue
905
906                 if [[ -f /etc/crypttab ]]; then
907                     while read _mapper _a _p _o; do
908                         [[ $_mapper = \#* ]] && continue
909                         [[ "$_d" -ef /dev/mapper/"$_mapper" ]] || continue
910                         [[ "$_o" ]] || _o="$_p"
911                 # skip mkswap swap
912                         [[ $_o == *swap* ]] && continue 2
913                     done < /etc/crypttab
914                 fi
915
916                 push host_devs "$(readlink -f "$dev")"
917                 break
918             done < /etc/fstab
919         done < /proc/swaps
920     fi
921 fi
922
923 _get_fs_type() {
924     [[ $1 ]] || return
925     if [[ -b /dev/block/$1 ]] && ID_FS_TYPE=$(get_fs_env "/dev/block/$1"); then
926         host_fs_types["$(readlink -f "/dev/block/$1")"]="$ID_FS_TYPE"
927         return 1
928     fi
929     if [[ -b $1 ]] && ID_FS_TYPE=$(get_fs_env "$1"); then
930         host_fs_types["$(readlink -f "$1")"]="$ID_FS_TYPE"
931         return 1
932     fi
933     if fstype=$(find_dev_fstype "$1"); then
934         host_fs_types["$1"]="$fstype"
935         return 1
936     fi
937     return 1
938 }
939
940 for dev in ${host_devs[@]}; do
941     _get_fs_type "$dev"
942     check_block_and_slaves_all _get_fs_type "$(get_maj_min "$dev")"
943 done
944
945 [[ -d $udevdir ]] \
946     || udevdir="$(pkg-config udev --variable=udevdir 2>/dev/null)"
947 if ! [[ -d "$udevdir" ]]; then
948     [[ -d /lib/udev ]] && udevdir=/lib/udev
949     [[ -d /usr/lib/udev ]] && udevdir=/usr/lib/udev
950 fi
951
952 [[ -d $systemdutildir ]] \
953     || systemdutildir=$(pkg-config systemd --variable=systemdutildir 2>/dev/null)
954
955 if ! [[ -d "$systemdutildir" ]]; then
956     [[ -d /lib/systemd ]] && systemdutildir=/lib/systemd
957     [[ -d /usr/lib/systemd ]] && systemdutildir=/usr/lib/systemd
958 fi
959
960 [[ -d $systemdsystemunitdir ]] \
961     || systemdsystemunitdir=$(pkg-config systemd --variable=systemdsystemunitdir 2>/dev/null)
962
963 [[ -d "$systemdsystemunitdir" ]] || systemdsystemunitdir=${systemdutildir}/system
964
965 [[ -d $systemdsystemconfdir ]] \
966     || systemdsystemconfdir=$(pkg-config systemd --variable=systemdsystemconfdir 2>/dev/null)
967
968 [[ -d "$systemdsystemconfdir" ]] || systemdsystemconfdir=/etc/systemd/system
969
970 export initdir dracutbasedir dracutmodules \
971     fw_dir drivers_dir debug no_kernel kernel_only \
972     omit_drivers mdadmconf lvmconf root_dev \
973     use_fstab fstab_lines libdirs fscks nofscks ro_mnt \
974     stdloglvl sysloglvl fileloglvl kmsgloglvl logfile \
975     debug host_fs_types host_devs sshkey add_fstab \
976     DRACUT_VERSION udevdir prefix filesystems drivers \
977     systemdutildir systemdsystemunitdir systemdsystemconfdir
978
979 # Create some directory structure first
980 [[ $prefix ]] && mkdir -m 0755 -p "${initdir}${prefix}"
981
982 [[ -h /lib ]] || mkdir -m 0755 -p "${initdir}${prefix}/lib"
983 [[ $prefix ]] && ln -sfn "${prefix#/}/lib" "$initdir/lib"
984
985 if [[ $prefix ]]; then
986     for d in bin etc lib sbin tmp usr var $libdirs; do
987         [[ "$d" == */* ]] && continue
988         ln -sfn "${prefix#/}/${d#/}" "$initdir/$d"
989     done
990 fi
991
992 if [[ $kernel_only != yes ]]; then
993     for d in usr/bin usr/sbin bin etc lib sbin tmp usr var $libdirs; do
994         [[ -e "${initdir}${prefix}/$d" ]] && continue
995         if [ -L "/$d" ]; then
996             inst_symlink "/$d" "${prefix}/$d"
997         else
998             mkdir -m 0755 -p "${initdir}${prefix}/$d"
999         fi
1000     done
1001
1002     for d in dev proc sys sysroot root run run/lock run/initramfs; do
1003         if [ -L "/$d" ]; then
1004             inst_symlink "/$d"
1005         else
1006             mkdir -m 0755 -p "$initdir/$d"
1007         fi
1008     done
1009
1010     ln -sfn ../run "$initdir/var/run"
1011     ln -sfn ../run/lock "$initdir/var/lock"
1012     ln -sfn ../run/log "$initdir/var/log"
1013 else
1014     for d in lib "$libdir"; do
1015         [[ -e "${initdir}${prefix}/$d" ]] && continue
1016         if [ -h "/$d" ]; then
1017             inst "/$d" "${prefix}/$d"
1018         else
1019             mkdir -m 0755 -p "${initdir}${prefix}/$d"
1020         fi
1021     done
1022 fi
1023
1024 if [[ $kernel_only != yes ]]; then
1025     mkdir -p "${initdir}/etc/cmdline.d"
1026     for _d in $hookdirs; do
1027         mkdir -m 0755 -p ${initdir}/lib/dracut/hooks/$_d
1028     done
1029     if [[ "$UID" = "0" ]]; then
1030         [ -c ${initdir}/dev/null ] || mknod ${initdir}/dev/null c 1 3
1031         [ -c ${initdir}/dev/kmsg ] || mknod ${initdir}/dev/kmsg c 1 11
1032         [ -c ${initdir}/dev/console ] || mknod ${initdir}/dev/console c 5 1
1033     fi
1034 fi
1035
1036 mods_to_load=""
1037 # check all our modules to see if they should be sourced.
1038 # This builds a list of modules that we will install next.
1039 for_each_module_dir check_module
1040 for_each_module_dir check_mount
1041
1042 [[ "$mods_to_load " == *01fips\ * ]] && export DRACUT_FIPS_MODE=1
1043
1044 _isize=0 #initramfs size
1045 modules_loaded=" "
1046 # source our modules.
1047 for moddir in "$dracutbasedir/modules.d"/[0-9][0-9]*; do
1048     _d_mod=${moddir##*/}; _d_mod=${_d_mod#[0-9][0-9]}
1049     if [[ "$mods_to_load" == *\ $_d_mod\ * ]]; then
1050         if [[ $show_modules = yes ]]; then
1051             printf "%s\n" "$_d_mod"
1052         else
1053             dinfo "*** Including module: $_d_mod ***"
1054         fi
1055         if [[ $kernel_only == yes ]]; then
1056             module_installkernel "$_d_mod" || {
1057                 dfatal "installkernel failed in module $_d_mod"
1058                 exit 1
1059             }
1060         else
1061             module_install "$_d_mod"
1062             if [[ $no_kernel != yes ]]; then
1063                 module_installkernel "$_d_mod" || {
1064                     dfatal "installkernel failed in module $_d_mod"
1065                     exit 1
1066                 }
1067             fi
1068         fi
1069         mods_to_load=${mods_to_load// $_d_mod /}
1070         modules_loaded+="$_d_mod "
1071
1072         #print the module install size
1073         if [ -n "$printsize" ]; then
1074             _isize_new=$(du -sk ${initdir}|cut -f1)
1075             _isize_delta=$((_isize_new - _isize))
1076             printf "%s\n" "$_d_mod install size: ${_isize_delta}k"
1077             _isize=$_isize_new
1078         fi
1079     fi
1080 done
1081 unset moddir
1082
1083 for i in $modules_loaded; do
1084     mkdir -p $initdir/lib/dracut
1085     printf "%s\n" "$i" >> $initdir/lib/dracut/modules.txt
1086 done
1087
1088 dinfo "*** Including modules done ***"
1089
1090 ## final stuff that has to happen
1091 if [[ $no_kernel != yes ]]; then
1092
1093     if [[ $drivers ]]; then
1094         hostonly='' instmods $drivers
1095     fi
1096
1097     if [[ $add_drivers ]]; then
1098         hostonly='' instmods -c $add_drivers
1099     fi
1100     if [[ $filesystems ]]; then
1101         hostonly='' instmods -c $filesystems
1102     fi
1103
1104     dinfo "*** Installing kernel module dependencies and firmware ***"
1105     dracut_kernel_post
1106     dinfo "*** Installing kernel module dependencies and firmware done ***"
1107
1108     if [[ $noimageifnotneeded == yes ]] && [[ $hostonly ]]; then
1109         if [[ ! -f "$initdir/lib/dracut/need-initqueue" ]] && \
1110             [[ -f ${initdir}/lib/modules/$kernel/modules.dep && ! -s ${initdir}/lib/modules/$kernel/modules.dep ]]; then
1111             for i in ${initdir}/etc/cmdline.d/*.conf; do
1112                 # We need no initramfs image and do not generate one.
1113                 [[ $i == "${initdir}/etc/cmdline.d/*.conf" ]] && exit 0
1114             done
1115         fi
1116     fi
1117 fi
1118
1119 if [[ $kernel_only != yes ]]; then
1120     (( ${#install_items[@]} > 0 )) && inst_multiple ${install_items[@]}
1121
1122     [[ $kernel_cmdline ]] && printf "%s\n" "$kernel_cmdline" >> "${initdir}/etc/cmdline.d/01-default.conf"
1123
1124     while pop fstab_lines line; do
1125         printf "%s\n" "$line 0 0" >> "${initdir}/etc/fstab"
1126     done
1127
1128     for f in $add_fstab; do
1129         cat "$f" >> "${initdir}/etc/fstab"
1130     done
1131
1132     if [ -d ${initdir}/$systemdutildir ]; then
1133         mkdir -p ${initdir}/etc/conf.d
1134         {
1135             printf "%s\n" "systemdutildir=\"$systemdutildir\""
1136             printf "%s\n" "systemdsystemunitdir=\"$systemdsystemunitdir\""
1137             printf "%s\n" "systemdsystemconfdir=\"$systemdsystemconfdir\""
1138         } > ${initdir}/etc/conf.d/systemd.conf
1139     fi
1140
1141     if [[ $DRACUT_RESOLVE_LAZY ]] && [[ $DRACUT_INSTALL ]]; then
1142         dinfo "*** Resolving executable dependencies ***"
1143         find "$initdir" -type f \
1144             '(' -perm -0100 -or -perm -0010 -or -perm -0001 ')' \
1145             -not -path '*.ko' -print0 \
1146         | xargs -r -0 $DRACUT_INSTALL ${initdir+-D "$initdir"} -R ${DRACUT_FIPS_MODE+-H} --
1147         dinfo "*** Resolving executable dependencies done***"
1148     fi
1149 fi
1150
1151 while pop include_src src && pop include_target tgt; do
1152     if [[ $src && $tgt ]]; then
1153         if [[ -f $src ]]; then
1154             inst $src $tgt
1155         else
1156             ddebug "Including directory: $src"
1157             mkdir -p "${initdir}/${tgt}"
1158             # check for preexisting symlinks, so we can cope with the
1159             # symlinks to $prefix
1160             for i in "$src"/*; do
1161                 [[ -e "$i" || -h "$i" ]] || continue
1162                 s=${initdir}/${tgt}/${i#$src/}
1163                 if [[ -d "$i" ]]; then
1164                     if ! [[ -e "$s" ]]; then
1165                         mkdir -m 0755 -p "$s"
1166                         chmod --reference="$i" "$s"
1167                     fi
1168                     cp --reflink=auto --sparse=auto -fa -t "$s" "$i"/*
1169                 else
1170                     cp --reflink=auto --sparse=auto -fa -t "$s" "$i"
1171                 fi
1172             done
1173         fi
1174     fi
1175 done
1176
1177 if [[ $kernel_only != yes ]]; then
1178     # make sure that library links are correct and up to date
1179     for f in /etc/ld.so.conf /etc/ld.so.conf.d/*; do
1180         [[ -f $f ]] && inst_simple "$f"
1181     done
1182     if ! ldconfig -r "$initdir"; then
1183         if [[ $UID = 0 ]]; then
1184             derror "ldconfig exited ungracefully"
1185         else
1186             derror "ldconfig might need uid=0 (root) for chroot()"
1187         fi
1188     fi
1189 fi
1190
1191 PRELINK_BIN="$(command -v prelink)"
1192 if [[ $UID = 0 ]] && [[ $PRELINK_BIN ]]; then
1193     if [[ $DRACUT_FIPS_MODE ]]; then
1194         dinfo "*** Installing prelink files ***"
1195         inst_multiple -o prelink /etc/prelink.conf /etc/prelink.conf.d/*.conf /etc/prelink.cache
1196     else
1197         dinfo "*** Pre-linking files ***"
1198         inst_multiple -o prelink /etc/prelink.conf /etc/prelink.conf.d/*.conf
1199         chroot "$initdir" "$PRELINK_BIN" -a
1200         rm -f -- "$initdir/$PRELINK_BIN"
1201         rm -fr -- "$initdir"/etc/prelink.*
1202         dinfo "*** Pre-linking files done ***"
1203     fi
1204 fi
1205
1206 if [[ $do_hardlink = yes ]] && command -v hardlink >/dev/null; then
1207     dinfo "*** Hardlinking files ***"
1208     hardlink "$initdir" 2>&1
1209     dinfo "*** Hardlinking files done ***"
1210 fi
1211
1212 # strip binaries
1213 if [[ $do_strip = yes ]] ; then
1214     for p in strip xargs find; do
1215         if ! type -P $p >/dev/null; then
1216             dinfo "Could not find '$p'. Not stripping the initramfs."
1217             do_strip=no
1218         fi
1219     done
1220 fi
1221
1222 if [[ $do_strip = yes ]] && ! [[ $DRACUT_FIPS_MODE ]]; then
1223     dinfo "*** Stripping files ***"
1224     find "$initdir" -type f \
1225         -executable -not -path '*/lib/modules/*.ko' -print0 \
1226         | xargs -r -0 strip -g 2>/dev/null
1227
1228     # strip kernel modules, but do not touch signed modules
1229     find "$initdir" -type f -path '*/lib/modules/*.ko' -print0 \
1230         | while read -r -d $'\0' f; do
1231         SIG=$(tail -c 28 "$f")
1232         [[ $SIG == '~Module signature appended~' ]] || { printf "%s\000" "$f"; }
1233     done | xargs -r -0 strip -g
1234
1235     dinfo "*** Stripping files done ***"
1236 fi
1237 if [[ $early_microcode = yes ]]; then
1238     dinfo "*** Generating early-microcode cpio image ***"
1239     ucode_dir=(amd-ucode intel-ucode)
1240     ucode_dest=(AuthenticAMD.bin GenuineIntel.bin)
1241     _dest_dir="$microcode_dir/d/kernel/x86/microcode"
1242     _dest_idx="0 1"
1243     mkdir -p $_dest_dir
1244     if [[ $hostonly ]]; then
1245         [[ $(get_cpu_vendor) == "AMD" ]] && _dest_idx="0"
1246         [[ $(get_cpu_vendor) == "Intel" ]] && _dest_idx="1"
1247     fi
1248     for idx in $_dest_idx; do
1249         _fw=${ucode_dir[$idx]}
1250         for _fwdir in $fw_dir; do
1251             if [[ -d $_fwdir && -d $_fwdir/$_fw ]]; then
1252                 _src="*"
1253                 dinfo "*** Constructing ${ucode_dest[$idx]} ****"
1254                 if [[ $hostonly ]]; then
1255                     _src=$(get_ucode_file)
1256                 fi
1257                 cat $_fwdir/$_fw/$_src > $_dest_dir/${ucode_dest[$idx]}
1258             fi
1259         done
1260     done
1261     (cd "$microcode_dir/d"; find . -print0 | cpio --null -o -H newc --quiet >../ucode.cpio)
1262 fi
1263
1264 rm -f -- "$outfile"
1265 dinfo "*** Creating image file ***"
1266 if [[ $early_microcode = yes ]]; then
1267     # The microcode blob is _before_ the initramfs blob, not after
1268     mv $microcode_dir/ucode.cpio $outfile.$$
1269 fi
1270 if ! ( umask 077; cd "$initdir"; find . -print0 | cpio --null -R 0:0 -H newc -o --quiet| \
1271     $compress >> "$outfile.$$"; ); then
1272     dfatal "dracut: creation of $outfile.$$ failed"
1273     exit 1
1274 fi
1275 mv -- "$outfile.$$" "$outfile"
1276 dinfo "*** Creating image file done ***"
1277
1278 if (( maxloglvl >= 5 )); then
1279     if [[ $allowlocal ]]; then
1280         "$dracutbasedir/lsinitrd.sh" "$outfile"| ddebug
1281     else
1282         lsinitrd "$outfile"| ddebug
1283     fi
1284 fi
1285
1286 exit 0